<?php declare(strict_types=1);

namespace Plugin\css_permanentCart\Migrations;

use JTL\Shop;
use JTL\Jtllog;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;





/**
 * Class Migration20221211123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20221211123301 extends Migration implements IMigration {
	/**
	 * @inheritdoc
	 */



	/*
	define('JTLLOG_LEVEL_EMERGENCY', 600);
	define('JTLLOG_LEVEL_ALERT', 550);
	define('JTLLOG_LEVEL_CRITICAL', 500);
	define('JTLLOG_LEVEL_ERROR', 400);
	define('JTLLOG_LEVEL_WARNING', 300);
	define('JTLLOG_LEVEL_NOTICE', 250);
	define('JTLLOG_LEVEL_INFO', 200);
	define('JTLLOG_LEVEL_DEBUG', 100);
*/

	public function JTLWriteLog($cLog = '', $nLevel = JTLLOG_LEVEL_INFO, $bForce = false) {
		if (\mb_strlen($cLog) > 0 && ($bForce || Jtllog::getSytemlogFlag(false))) {
			$logger = Shop::Container()->getLogService();
			$logger = $logger->withName("css_permanentCart");
			$logger->log($nLevel, $cLog, ["css_permanentCart"]);
			return true;
		}
		return false;
	}


	public function up() {
		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_permanentCartConfig` (
                  `version` varchar(255) NOT NULL DEFAULT '1.0.0',
                  `cookieNameBasket` varchar(250) NOT NULL default 'css_PermanentCart',
                  `cookieNameNotepad` varchar(250) NOT NULL default 'css_PermanentNotepad',
                  `cookieTime` int(10) NOT NULL default '10',
                  `maxBaskets` int(10) NOT NULL default '5',
                  `hasImport` int(10) NOT NULL default '0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `framework` char(3) NOT NULL default 'B4',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
                  `selector_myAccount` varchar(255) NOT NULL DEFAULT '#account > .col > .row:last-child,#snackys-tpl #account a.btn-danger',
                  `selector_myAccount_position` varchar(255) NOT NULL DEFAULT 'before',
                  `selector` varchar(255) NOT NULL DEFAULT '#content-wrapper',
                  `selector_position` varchar(255) NOT NULL DEFAULT 'prepend'
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_permanentCartBasket` (
								  `kBasket` int(10) NOT NULL AUTO_INCREMENT,
                  `kKunde` int(11) NOT NULL default '0',
                  `creationTime` int(11) NOT NULL default '0',
                  `cBasketName` varchar(50) NOT NULL default '',
                  `cHash` varchar(60) NOT NULL default '',
       					  PRIMARY KEY (`kBasket`)
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_permanentCartBasketPos` (
								  `kBasketPos` int(10) NOT NULL AUTO_INCREMENT,
								  `kBasket` int(10) NOT NULL default '0',
								  `kArtikel` int(10) NOT NULL default '0',
								  `nAnzahl` double(10,4)	 NOT NULL default '0.0000',
                  `cHash` varchar(60) NOT NULL default '',
                  `cArtikelName` TEXT NOT NULL,
                  `Property` TEXT NOT NULL,
								  `cUnique` varchar(255) NOT NULL,
								  `cResponsibility` varchar(255) NOT NULL DEFAULT 'core',
								  `kKonfigitem` int(10) UNSIGNED NOT NULL,
								  `nPosTyp` tinyint(3) UNSIGNED NOT NULL DEFAULT 1,
                  `creationTime` int(11) NOT NULL default '0',
       					  PRIMARY KEY (`kBasketPos`)
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_permanentCartNotepad` (
								  `kNotepad` int(10) NOT NULL AUTO_INCREMENT,
                  `creationTime` int(11) NOT NULL default '0',
                  `cHash` varchar(60) NOT NULL default '',
       					  PRIMARY KEY (`kNotepad`)
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");

		$this->execute("
              CREATE TABLE IF NOT EXISTS `css_permanentCartNotepadPos` (
								  `kNotepadPos` int(10) NOT NULL AUTO_INCREMENT,
								  `kNotepad` int(10) NOT NULL default '0',
								  `kArtikel` int(10) NOT NULL default '0',
								  `nAnzahl` double(10,4)	 NOT NULL default '0.0000',
                  `cHash` varchar(60) NOT NULL default '',
                  `Property` TEXT NOT NULL ,
                  `creationTime` int(11) NOT NULL default '0',
       					  PRIMARY KEY (`kNotepadPos`)
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");


		$this->execute("
							UPDATE `teinstellungen` SET cWert='N' WHERE `cName` = 'warenkorbpers_nutzen'
			");
		$this->execute("
							UPDATE `teinstellungen` SET cWert='N' WHERE `cName` = 'warenkorb_warenkorb2pers_merge'
			");


		$result = $this->getDB()->query(
			'SELECT * from `css_permanentCartConfig` where 1',
			2
		);

		if ($result === null || count($result) < 1) {
			$this->execute("ALTER TABLE `css_permanentCartBasket`
  ADD KEY `cHash` (`cHash`),
  ADD KEY `creationTime` (`creationTime`)
  ");

			$this->execute("ALTER TABLE `css_permanentCartBasketPos`
  ADD KEY `kBasket` (`kBasket`)
  ");

			$this->execute(
				"INSERT INTO `css_permanentCartConfig` (`version`) VALUES ('1.0.0')"
			);
		} else {
			$this->execute("UPDATE css_permanentCartConfig set `version` = '1.0.0' ");
		}
	}

	/**
	 * @inheritdoc
	 */
	public function down() {
	}
}
